/**
 * Dream
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: dream@objectweb.org
 *
 * Initial developer(s): Matthieu Leclercq
 * Contributor(s): 
 */

package org.objectweb.dream.adl.legacy;

/**
 * Exception thrown by
 * {@link org.objectweb.dream.adl.Resolver#resolve(Object, String, java.util.Map)}
 * method.
 */
public class ComponentNotFoundException extends Exception
{

  Object context;
  Object name;

  /**
   * Default constructor
   * 
   * @param message a message.
   * @param context the context
   * @param name the name
   */
  public ComponentNotFoundException(String message, Object context, Object name)
  {
    super(message);
    this.context = context;
    this.name = name;
  }

  /**
   * @see java.lang.Object#toString()
   */
  public String toString()
  {
    return "Unable to find legacy component. context=" + context + ", name="
        + name + " : " + getLocalizedMessage();
  }

}