/**
 * Copyright (C) 2002
 */

package org.objectweb.util.monolog.wrapper.log4jMini;

import org.apache.log4j.FileAppender;
import org.apache.log4j.PatternLayout;
import org.objectweb.util.monolog.api.Handler;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * This class is the wrapper to the org.apache.log4j.FileAppender
 *
 * @author Sebastien Chassande-Barrioz
 */
public class FileHandler extends FileAppender implements Handler {

	protected byte type = 0;
	protected Hashtable props = null;

	/**
	 * It Builds a new MonologFileHandler. It is needed to specify an handler
	 * type.
	 * @param ht 	is the handler type. The possible values are the
	 * 				HandlerFactory.FILE_HANDLER_TYPE or
	 * 				HandlerFactory.CONSOLE_HANDLER_TYPE.
	 */
	public FileHandler(byte type, String name) {
		super();
		this.type = type;
		setName(name);
		props = new Hashtable(3);
	}

	// IMPLEMENTATION OF THE Handler INTERFACE //
	//---------------------------------------------//

	public byte getType() {
		return type;
	}

	public String[] getAttributeNames() {
		String[] res = new String[props.size()];
		int i=0;
		for(Enumeration en=props.keys(); en.hasMoreElements();) {
			res[i++] = (String) en.nextElement();
		}
		return res;
	}

	public Object getAttribute(String key) {
		return props.get(key);
	}

	public Object setAttribute(String key, Object value) {
		props.put(key, value);
		if (key.equalsIgnoreCase(Handler.OUTPUT_ATTRIBUTE)) {
            if (type == Handler.CONSOLE_HANDLER_TYPE) {
			    setOption(FILE_OPTION, (String) value);
            } else if (type == Handler.FILE_HANDLER_TYPE) {
                try {
                    fileName=(String) value;
                    setFile(fileName);

                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
		}
		else if (key.equalsIgnoreCase(Handler.PATTERN_ATTRIBUTE)) {
			setLayout(
				new PatternLayout(
					PatternConverter.monolog2log4j((String) value)));
		}
		else if (key.equalsIgnoreCase(Handler.APPEND_MODE_ATTRIBUTE)) {
            setOption(APPEND_OPTION, (String) value);
			fileAppend = new Boolean( (String) value).booleanValue();
			/*try {
				setFile(fileName, fileAppend);
			}
			catch (IOException e) {
                  e.printStackTrace();
			} */
		}
		return null;
	}
}
